/* Problem URL: https://codeforces.com/problemset/problem/1930/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

struct dymseg {
    struct node {
        int left;
        int right;
        int val;
    };

    V<node> seg;

    dymseg(int n) {
        seg.emplace_back(-1, -1, 0);
    }

    int create_node() {
        seg.emplace_back(-1, -1, 0);
        return seg.size() - 1;
    }

    void create_nodes(int i) {
        if (seg[i].left == -1) {
            seg[i].left = create_node();
        }

        if (seg[i].right == -1) {
            seg[i].right = create_node();
        }
    }

    void update(int i, ll l, ll r, int p) {
        if (l == r) {
            seg[i].val = 1;
            return;
        }
        
        seg[i].val++;

        create_nodes(i);

        ll mid = (l + r) >> 1;

        if (mid >= p) {
            update(seg[i].left, l, mid, p);
            return;
        }

        update(seg[i].right, mid + 1, r, p);
    }

    ll tl, tr;

    ll query(int i, ll l, ll r) {
        if (l > tr || r < tl || seg[i].val == r - l + 1) {
            return -1;
        }

        if (l == r) {
            return l;
        }

        ll mid = (l + r) >> 1;
        
        create_nodes(i);

        int ans = query(seg[i].right, mid + 1, r);

        if (ans != -1) {
            return ans;
        }

        return query(seg[i].left, l, mid);
    }

    public:
    void update(ll p) {
        update(0, 0, 1LL << 31, p);
    }

    ll query(ll l, ll r) {
        tl = l;
        tr = r;
        return query(0, 0, 1LL << 31);
    }
};

void solve()
{
    int n;
    cin >> n;

    vl a(n);
    cin >> a;

    dymseg seg(n);

    set<ll, greater<>> ans;
    rep(i, n) {
        ll choice = seg.query(a[i], a[i] + i + 1);
        if (choice == -1) {
            continue;
        }

        ans.insert(choice);
        seg.update(choice);
    }

    repv(i, ans) {
        cout << i << ' ';
    }
    cout << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
